=== debian/changelog ===
hipify (6.0.2+dfsg-1) unstable; urgency=medium

  * Migrate to unstable
  * hipify-clang now recommends nvidia-cuda-toolkit

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 22 Apr 2024 03:07:17 -0600

hipify (6.0.2+dfsg-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1063741)

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 11 Feb 2024 23:17:57 -0700
