=== debian/rules ===
#!/usr/bin/make -f
export VERBOSE=1

%:
	dh $@ -Scmake

# dwz does not support DWARF-5
override_dh_dwz:
	:
