=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//,oversionmangle=s/(.*)/$1+dfsg/,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipify-$1.tar.gz%" \
    https://github.com/rocm/hipify/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
