## hipify 6.4.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,11 @@
 option(HIPIFY_CLANG_TESTS "Build HIPIFY tests, if lit is installed" OFF)
 option(HIPIFY_CLANG_TESTS_ONLY "Build HIPIFY tests only, if lit is installed and hipify-clang binary is already produced" OFF)
 option(HIPIFY_INCLUDE_IN_HIP_SDK "Include HIPIFY in HIP SDK" OFF)
+option(HIPIFY_INSTALL_CLANG_HEADERS "Include clang headers in HIPIFY installation" ON)
+
+if(NOT WIN32)
+  set(CPACK_SET_DESTDIR ON CACHE BOOL "Installer package will install hipify to CMAKE_INSTALL_PREFIX instead of CPACK_PACKAGING_INSTALL_PREFIX")
+endif()
 
 if(HIPIFY_CLANG_TESTS OR HIPIFY_CLANG_TESTS_ONLY)
   set(HIPIFY_TEST "ON")
@@ -21,9 +26,10 @@
 endif()
 
 message(STATUS "HIPIFY config:")
-message(STATUS "   - Build hipify-clang : ${HIPIFY_BUILD}")
-message(STATUS "   - Test  hipify-clang : ${HIPIFY_TEST}")
-message(STATUS "   - Is part of HIP SDK : ${HIPIFY_INCLUDE_IN_HIP_SDK}")
+message(STATUS "   - Build hipify-clang    : ${HIPIFY_BUILD}")
+message(STATUS "   - Test hipify-clang     : ${HIPIFY_TEST}")
+message(STATUS "   - Is part of HIP SDK    : ${HIPIFY_INCLUDE_IN_HIP_SDK}")
+message(STATUS "   - Install clang headers : ${HIPIFY_INSTALL_CLANG_HEADERS}")
 
 if(HIPIFY_INCLUDE_IN_HIP_SDK)
   if(NOT WIN32)
@@ -36,10 +42,10 @@
   find_package(LLVM REQUIRED CONFIG PATHS ${CMAKE_PREFIX_PATH})
 
   message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}:")
-  message(STATUS "   - CMake module path  : ${LLVM_CMAKE_DIR}")
-  message(STATUS "   - Clang include path : ${CLANG_INCLUDE_DIRS}")
-  message(STATUS "   - LLVM Include path  : ${LLVM_INCLUDE_DIRS}")
-  message(STATUS "   - Binary path        : ${LLVM_TOOLS_BINARY_DIR}")
+  message(STATUS "   - CMake module path     : ${LLVM_CMAKE_DIR}")
+  message(STATUS "   - Clang include path    : ${CLANG_INCLUDE_DIRS}")
+  message(STATUS "   - LLVM Include path     : ${LLVM_INCLUDE_DIRS}")
+  message(STATUS "   - Binary path           : ${LLVM_TOOLS_BINARY_DIR}")
 endif()
 
 list(APPEND CMAKE_MODULE_PATH ${LLVM_CMAKE_DIR})
@@ -139,7 +145,7 @@
 
   if(MSVC)
     target_link_libraries(hipify-clang PRIVATE version)
-    target_compile_options(hipify-clang PRIVATE ${STD} /Od /GR- /EHs- /EHc-)
+    target_compile_options(hipify-clang PRIVATE ${STD} /Od /GR- /EHs- /EHc- /MP)
     if((LLVM_PACKAGE_VERSION VERSION_EQUAL "18.0.0" OR LLVM_PACKAGE_VERSION VERSION_GREATER "18.0.0") AND MSVC_VERSION VERSION_GREATER "1919")
       target_compile_options(hipify-clang PRIVATE /Zc:preprocessor)
     endif()
@@ -161,7 +167,7 @@
   else()
     set(LIB_CLANG_RES ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
   endif()
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CFLAGS} -DHIPIFY_CLANG_RES=\\\"${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}\\\" ${addr_var}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_CFLAGS} -DLIB_CLANG_RES=${LIB_CLANG_RES} ${addr_var}")
 
   set(INSTALL_PATH_DOC_STRING "hipify-clang Installation Path")
   if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -175,25 +181,44 @@
   install(
     DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin
     DESTINATION .
-    USE_SOURCE_PERMISSIONS
     PATTERN "hipify-perl"
-    PATTERN "*.sh")
+    PATTERN "*.sh"
+    PATTERN "findcode.sh" EXCLUDE
+    PATTERN "findcode_headers.sh" EXCLUDE
+    PATTERN "findcode_sources.sh" EXCLUDE
+    PATTERN "findcode_custom.sh" EXCLUDE
+    PATTERN "finduncodep.sh" EXCLUDE)
+
+  set(HIPIFY_LIBEXEC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}/hipify")
+
+  install(
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_headers.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_sources.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/findcode_custom.sh
+    PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/finduncodep.sh
+    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/hipify)
 
   # Headers are already included in HIP SDK, so skip those if including HIPIFY in HIP SDK.
-  if(NOT HIPIFY_INCLUDE_IN_HIP_SDK)
-    # Install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path.
-    install(
-      DIRECTORY ${LLVM_DIR}/../../clang/${LIB_CLANG_RES}/
-      DESTINATION .
-      COMPONENT clang-resource-headers
-      FILES_MATCHING
-      PATTERN "*.h"
-      PATTERN "*.modulemap"
-      PATTERN "algorithm"
-      PATTERN "complex"
-      PATTERN "new"
-      PATTERN "ppc_wrappers" EXCLUDE
-      PATTERN "openmp_wrappers" EXCLUDE)
+  if( HIPIFY_INSTALL_CLANG_HEADERS)
+    if(NOT HIPIFY_INCLUDE_IN_HIP_SDK)
+      # Install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path.
+      install(
+        DIRECTORY ${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}/include/
+        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/hipify/${CMAKE_INSTALL_INCLUDEDIR}
+        COMPONENT clang-resource-headers
+        FILES_MATCHING
+        PATTERN "*.h"
+        PATTERN "*.modulemap"
+        PATTERN "algorithm"
+        PATTERN "complex"
+        PATTERN "new"
+        PATTERN "ppc_wrappers" EXCLUDE
+        PATTERN "omp-tools.h" EXCLUDE
+        PATTERN "omp.h" EXCLUDE
+        PATTERN "ompt.h" EXCLUDE
+        PATTERN "openmp_wrappers" EXCLUDE)
+    endif()
   endif()
 
 # install all folders under clang/version/ in CMAKE_INSTALL_PREFIX path
@@ -244,10 +269,12 @@
 
   message(STATUS "---- The below configuring for hipify-clang testing only ----")
 
+  set (HIPIFY_CLANG_RES "${LLVM_LIBRARY_DIRS}/clang/${LIB_CLANG_RES}")
+
   if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
-    find_package(PythonInterp 2.7 REQUIRED)
-  else()
-    find_package(Python 2.7...3.12 REQUIRED)
+    find_package(PythonInterp 3.0 REQUIRED)
+  else()
+    find_package(Python 3.0...3.14 REQUIRED)
   endif()
 
   function (require_program PROGRAM_NAME)
@@ -262,12 +289,13 @@
   require_program(lit)
   require_program(FileCheck)
 
-  set(CUDA_TOOLKIT_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit to use in hipify-clang unit testing")
-  set(CUDA_SDK_ROOT_DIR OFF CACHE PATH "Path to CUDA Toolkit Samples")
-  set(CUDA_DNN_ROOT_DIR OFF CACHE PATH "Path to cuDNN")
-  set(CUDA_CUB_ROOT_DIR OFF CACHE PATH "Path to CUB")
-
-  if(DEFINED CUDA_TOOLKIT_ROOT_DIR AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
+  set(CUDA_TOOLKIT_ROOT_DIR "" CACHE PATH "Path to CUDA Toolkit to use in hipify-clang unit testing")
+  set(CUDA_SDK_ROOT_DIR     "" CACHE PATH "Path to CUDA Toolkit Samples")
+  set(CUDA_DNN_ROOT_DIR     "" CACHE PATH "Path to cuDNN")
+  set(CUDA_TENSOR_ROOT_DIR  "" CACHE PATH "Path to cuTENSOR")
+  set(CUDA_CUB_ROOT_DIR     "" CACHE PATH "Path to CUB")
+
+  if(NOT CUDA_TOOLKIT_ROOT_DIR STREQUAL "" AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
     if(NOT DEFINED CUDAToolkit_ROOT OR CUDAToolkit_ROOT MATCHES "OFF")
       set(CUDAToolkit_ROOT "${CUDA_TOOLKIT_ROOT_DIR}")
     endif()
@@ -278,10 +306,11 @@
   endif()
 
   message(STATUS "Initial CUDA to configure:")
-  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
-  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
-  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
-  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")
+  message(STATUS "   - CUDA Toolkit path     : ${CUDA_TOOLKIT_ROOT_DIR}")
+  message(STATUS "   - CUDA Samples path     : ${CUDA_SDK_ROOT_DIR}")
+  message(STATUS "   - cuDNN path            : ${CUDA_DNN_ROOT_DIR}")
+  message(STATUS "   - cuTENSOR path         : ${CUDA_TENSOR_ROOT_DIR}")
+  message(STATUS "   - CUB path              : ${CUDA_CUB_ROOT_DIR}")
 
   if(${CMAKE_VERSION} VERSION_LESS "3.27.0")
     find_package(CUDA REQUIRED)
@@ -296,25 +325,3 @@
     set(CUDA_TOOLKIT_ROOT_DIR "${CUDAToolkit_LIBRARY_ROOT}")
   endif()
 
-  if(WIN32 AND CUDA_VERSION VERSION_LESS "11.6" AND CUDA_SDK_ROOT_DIR STREQUAL "OFF" AND NOT CUDA_TOOLKIT_ROOT_DIR MATCHES "OFF")
-    set(NVCUDASAMPLES "NVCUDASAMPLES${CUDA_VERSION_MAJOR}_${CUDA_VERSION_MINOR}_ROOT")
-    if(DEFINED ENV{${NVCUDASAMPLES}})
-      set(CUDA_SDK_ROOT_DIR "$ENV{${NVCUDASAMPLES}}")
-      string(REPLACE "\\" "/" CUDA_SDK_ROOT_DIR ${CUDA_SDK_ROOT_DIR})
-    endif()
-  endif()
-
-  message(STATUS "Found CUDA config:")
-  message(STATUS "   - CUDA Toolkit path  : ${CUDA_TOOLKIT_ROOT_DIR}")
-  message(STATUS "   - CUDA Samples path  : ${CUDA_SDK_ROOT_DIR}")
-  message(STATUS "   - cuDNN path         : ${CUDA_DNN_ROOT_DIR}")
-  message(STATUS "   - CUB path           : ${CUDA_CUB_ROOT_DIR}")
-
-  if((CUDA_VERSION VERSION_LESS "7.0") OR (LLVM_PACKAGE_VERSION VERSION_LESS "3.8") OR
-     (CUDA_VERSION VERSION_GREATER "7.5" AND LLVM_PACKAGE_VERSION VERSION_LESS "4.0") OR
-     (CUDA_VERSION VERSION_GREATER "8.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "6.0") OR
-     (CUDA_VERSION VERSION_GREATER "9.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "7.0") OR
-     (CUDA_VERSION VERSION_GREATER "9.2" AND LLVM_PACKAGE_VERSION VERSION_LESS "8.0") OR
-     (CUDA_VERSION VERSION_GREATER "10.0" AND LLVM_PACKAGE_VERSION VERSION_LESS "9.0") OR
-     (CUDA_VERSION VERSION_GREATER "10.1" AND LLVM_PACKAGE_VERSION VERSION_LESS "10.0"))
-    message(SEND_ERROR "CUDA ${CUDA_VERSION} is not supported by LLVM ${LLVM_PACKAGE_VERSION}.")
