=== debian/changelog ===
hipify (6.4.3+dfsg-1~exp1) experimental; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Igor Luppi ]
  * New upstream version 6.4.3+dfsg
  * Update build-deps from LLVM 17 to LLVM 20 (Closes: #1084069)
  * Update link libraries for LLVM 20
  * Omit find-shell scripts from installation

  [ Cordell Bloor ]
  * Update my email address
  * Enable hardening flags
  * Update standards version to 4.7.2. No changes required.
  * Set hipify-perl interpreter to /usr/bin/perl
  * Add d/p/use-system-clang-resource-directory.patch to ensure
    hipify-clang can find the LLVM 20 resource directory
  * Add d/gbp.conf with the package defaults for pristine-tar
    and patch numbering
  * Verify 6.4.3+dfsg builds with GCC-15 (Closes: #1096810)

 -- Cordell Bloor <cgmb@debian.org>  Wed, 10 Sep 2025 19:12:29 -0600
