=== debian/control ===
--- 
+++ 
@@ -2,18 +2,18 @@
 Section: devel
 Homepage: https://github.com/ROCm/HIPIFY
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipify.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipify
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Cordell Bloor <cgmb@slerp.xyz>
+Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- clang-17,
+ clang-20,
  cmake,
- libclang-17-dev,
+ libclang-20-dev,
  libzstd-dev,
- llvm-17-dev,
+ llvm-20-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
