=== debian/changelog ===
hipify (7.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version 7.0.2+dfsg
  * Upload to unstable
  * Update Build-Depends from LLVM 20 to LLVM 21
  * Update d/gbp.conf to follow DEP-14

 -- Cordell Bloor <cgmb@debian.org>  Fri, 17 Oct 2025 18:55:24 -0600
