=== debian/control ===
--- 
+++ 
@@ -9,11 +9,11 @@
 Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- clang-20,
+ clang-21,
  cmake,
- libclang-20-dev,
+ libclang-21-dev,
  libzstd-dev,
- llvm-20-dev,
+ llvm-21-dev,
  zlib1g-dev,
 Rules-Requires-Root: no
