=== debian/rules ===
#!/usr/bin/make -f
export VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_install:
	dh_auto_install
	sed -i 's@#!/usr/bin/env perl@#!/usr/bin/perl@' ./debian/tmp/usr/bin/hipify-perl

# dwz does not support DWARF-5
override_dh_dwz:
	:
