=== debian/watch ===
Version: 5

Source: https://github.com/rocm/hipify/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Dversionmangle: s/\+dfsg//
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipify-$1.tar.gz%
Oversionmangle: s/(.*)/$1+dfsg/
