## hipify 7.1.0+dfsg

=== debian/changelog ===
hipify (7.1.0+dfsg-0ubuntu3) resolute; urgency=medium

  * Revert to LLVM 21 toolchain (from ROCm LLVM fork)
    - d/control: revert build-depends to llvm-toolchain-21
    - d/rules: remove ROCm-specific CMake configuration and shlibdeps override
    - d/p/remove-redundant-target_link_libraries.patch: restore patch
    - d/p/fix-monolithic-clang-cpp-and-rpath.patch: drop ROCm patch
    - d/p/use-system-clang-resource-directory.patch: revert to LLVM 21 paths

 -- Igor Luppi <igor.luppi@canonical.com>  Mon, 20 Jan 2026 00:00:00 +0000

hipify (7.1.0+dfsg-0ubuntu2) resolute; urgency=medium

  * d/control: fix missing runtime dependency
    - adding clang-rocm as depends for bin:hipify-clang
  * d/t/hipify: remove unnecessary flag for autopkgtest

 -- Igor Luppi <igor.luppi@canonical.com>  Thu, 11 Dec 2025 15:53:16 -0300

hipify (7.1.0+dfsg-0ubuntu1) resolute; urgency=medium

  * chore: New upstream version 7.1.0
  * d/rules: explicitly point CMake to ROCm configuration
  * d/rules: fix shlibdeps lookup for private ROCm libraries
  * d/rules: optimize linker flags for binary size and dependencies
  * d/control: update build-depends for ROCm LLVM toolchain
  * d/p/remove-redundant-target_link_libraries.patch: drop patch
  * d/p/fix-monolithic-clang-cpp-and-rpath.patch: new patch to fix clang link
    with llvm-toolchain-rocm.
  * d/p/use-system-clang-resource-directory.patch: update clang path for ROCm
  * d/t/{control,hipify}: include autopkgtests for hipify-{clang,perl}

 -- Igor Luppi <igor.luppi@canonical.com>  Thu, 27 Nov 2025 18:30:17 -0300
