=== debian/control ===
--- 
+++ 
@@ -5,11 +5,15 @@
 Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipify.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipify
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Cordell Bloor <cgmb@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  clang-21,
+ clang-tools-21,
+ clang-format-21,
+ clang-tidy-21,
  cmake,
  libclang-21-dev,
  libzstd-dev,
@@ -22,6 +26,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         libclang-common-21-dev,
 Recommends: nvidia-cuda-toolkit
 Description: CUDA to HIP source-to-source translation tool
  hipify-clang is a tool that converts CUDA sources to HIP. It is built on
