=== debian/tests/control ===
Tests: hipify
Depends: hipify-clang, hipify-perl, nvidia-cuda-toolkit
Restrictions: allow-stderr
